
#include "d_vector.h"
template <typename T>
class stack
{	public:
		stack();
		// constructor. creates an empty stack.

		void push(const T& item);
		// push (insert) item onto the stack.
		// Postcond: the stack has a new topmost element and the stack size increases by 1

		void pop();
		// remove the item from the top of the stack
		// Precond:  the stack is not empty.
		
		T & top();
		// return of reference to the element on the top of the stack
		// Precond:  the stack is not empty.
	
		const T& top() const;
		// constant version of top

		bool empty() const;
		// determine whether the stack is empty

		int size() const;
		// return the number of elements in the stack

	private:
		Vector<T> stackVector;
		// a vector object maintains the stack items and size.
};

template <typename T>
stack<T>::stack()
{}

template <typename T>
void stack<T>::push(const T & item)
{	stackVector.push_back(item);
}

template <typename T>
void stack<T>::pop()
{	stackVector.pop_back();
}

template <typename T>
T & stack<T>::top()
{	return stackVector.back();
}

template <typename T>
const T & stack<T>::top() const
{	return stackVector.back();
}

template <typename T>
bool stack<T>::empty() const
{	return stackVector.empty();
}

template <typename T>
int stack<T>::size() const
{	return stackVector.size();
}